Ameba::Reportable - ameba 1.7.0

# module Ameba::Reportable

##
Overview

Represents a module used to report issues.

##
Included Modules

- Ameba::AST::Util

##
Direct including types

- Ameba::Source

##
Defined in:

ameba/reportable.cr

##
Instance Method Summary

- #add_issue(rule, location : Crystal::Location | Nil, end_location : Crystal::Location | Nil, message : String, status : Issue::Status | Nil = nil, block : Source::Corrector -> | Nil = nil) : Issue

  Adds a new issue to the list of issues.

- #add_issue(rule, location : Crystal::Location | Nil, end_location : Crystal::Location | Nil, message : String, status : Issue::Status | Nil = nil, &block : Source::Corrector -> ) : Issue

  Adds a new issue to the list of issues.

- #add_issue(rule, location : Tuple(Crystal::Location, Crystal::Location), message : String, status : Issue::Status | Nil = nil, block : Source::Corrector -> | Nil = nil) : Issue

  Adds a new issue for location defined by line and column numbers.

- #add_issue(rule, token : Crystal::Token, message : String, status : Issue::Status | Nil = nil, block : Source::Corrector -> | Nil = nil) : Issue

  Adds a new issue for Crystal token.

- #add_issue(rule, location : Tuple(Int32, Int32), message : String, status : Issue::Status | Nil = nil, block : Source::Corrector -> | Nil = nil) : Issue

  Adds a new issue for location defined by line and column numbers.

- #add_issue(rule, location : Tuple(Int32, Int32), end_location : Tuple(Int32, Int32), message : String, status : Issue::Status | Nil = nil, block : Source::Corrector -> | Nil = nil) : Issue

  Adds a new issue for location and end_location defined by line and column numbers.

- #add_issue(rule, node : Crystal::ASTNode, message : String, status : Issue::Status | Nil = nil, block : Source::Corrector -> | Nil = nil, *, prefer_name_location = false) : Issue

  Adds a new issue for Crystal AST node.

- #add_issue(rule, location : Tuple(Int32, Int32), message : String, status : Issue::Status | Nil = nil, &block : Source::Corrector -> ) : Issue

  Adds a new issue for location defined by line and column numbers.

- #add_issue(rule, token : Crystal::Token, message : String, status : Issue::Status | Nil = nil, &block : Source::Corrector -> ) : Issue

  Adds a new issue for Crystal token.

- #add_issue(rule, location : Tuple(Int32, Int32), end_location : Tuple(Int32, Int32), message : String, status : Issue::Status | Nil = nil, &block : Source::Corrector -> ) : Issue

  Adds a new issue for location and end_location defined by line and column numbers.

- #add_issue(rule, node : Crystal::ASTNode, message : String, status : Issue::Status | Nil = nil, *, prefer_name_location = false, &block : Source::Corrector -> ) : Issue

  Adds a new issue for Crystal AST node.

- #issues

  List of reported issues.

- #valid?

  Returns `true` if the list of not disabled issues is empty, `false` otherwise.

### Instance methods inherited from module `Ameba::AST::Util`

abort?(node) abort?, control_exp_code(node : Crystal::ControlExpression, code_lines) control_exp_code, dynamic_literal?(node) : Bool dynamic_literal?, each_inline_directive(source, &block : Crystal::Token, String, Array(String) -> _) each_inline_directive, exit?(node) exit?, flow_command?(node, in_loop) flow_command?, flow_expression?(node, in_loop = false) flow_expression?, has_arguments?(node) : Bool has_arguments?, has_block?(node) : Bool has_block?, has_short_block?(node, code_lines) has_short_block?, heredoc?(node : Crystal::ASTNode, source : Source) heredoc?, literal?(node) : Bool literal?, loop?(node) loop?, name_end_location(node) name_end_location, name_location(node) name_location, name_location_or(token : Crystal::Token, name, *, adjust_location_column_number = nil)
name_location_or(node : Crystal::ASTNode, *, adjust_location_column_number = nil) name_location_or, name_size(node) name_size, node_source(node, code_lines) node_source, nodoc?(node) nodoc?, operator_method?(node) operator_method?, operator_method_name?(name : String) operator_method_name?, path_name(node : Crystal::Path, *, include_global = true) : String path_name, path_named?(node, *names : String) : Bool path_named?, raise?(node) raise?, setter_method?(node) setter_method?, setter_method_name?(name : String) setter_method_name?, short_block?(node, code_lines) short_block?, source_between(loc, end_loc, code_lines) : String | Nil source_between, static_literal?(node) : Bool static_literal?, suffix?(node) suffix?, takes_arguments?(node) : Bool takes_arguments?

##
Instance Method Detail

def add_issue(rule, location : Crystal::Location | Nil, end_location : Crystal::Location | Nil, message : String, status : Issue::Status | Nil = nil, block : Source::Corrector -> | Nil = nil) : Issue #

Adds a new issue to the list of issues.

def add_issue(rule, location : Crystal::Location | Nil, end_location : Crystal::Location | Nil, message : String, status : Issue::Status | Nil = nil, &block : Source::Corrector -> ) : Issue #

Adds a new issue to the list of issues.

def add_issue(rule, location : Tuple(Crystal::Location, Crystal::Location), message : String, status : Issue::Status | Nil = nil, block : Source::Corrector -> | Nil = nil) : Issue #

Adds a new issue for location defined by line and column numbers.

def add_issue(rule, token : Crystal::Token, message : String, status : Issue::Status | Nil = nil, block : Source::Corrector -> | Nil = nil) : Issue #

Adds a new issue for Crystal token.

def add_issue(rule, location : Tuple(Int32, Int32), message : String, status : Issue::Status | Nil = nil, block : Source::Corrector -> | Nil = nil) : Issue #

Adds a new issue for location defined by line and column numbers.

def add_issue(rule, location : Tuple(Int32, Int32), end_location : Tuple(Int32, Int32), message : String, status : Issue::Status | Nil = nil, block : Source::Corrector -> | Nil = nil) : Issue #

Adds a new issue for location and end_location defined by line and column numbers.

def add_issue(rule, node : Crystal::ASTNode, message : String, status : Issue::Status | Nil = nil, block : Source::Corrector -> | Nil = nil, *, prefer_name_location = false) : Issue #

Adds a new issue for Crystal AST node.

def add_issue(rule, location : Tuple(Int32, Int32), message : String, status : Issue::Status | Nil = nil, &block : Source::Corrector -> ) : Issue #

Adds a new issue for location defined by line and column numbers.

def add_issue(rule, token : Crystal::Token, message : String, status : Issue::Status | Nil = nil, &block : Source::Corrector -> ) : Issue #

Adds a new issue for Crystal token.

def add_issue(rule, location : Tuple(Int32, Int32), end_location : Tuple(Int32, Int32), message : String, status : Issue::Status | Nil = nil, &block : Source::Corrector -> ) : Issue #

Adds a new issue for location and end_location defined by line and column numbers.

def add_issue(rule, node : Crystal::ASTNode, message : String, status : Issue::Status | Nil = nil, *, prefer_name_location = false, &block : Source::Corrector -> ) : Issue #

Adds a new issue for Crystal AST node.

def issues #

List of reported issues.

def valid? #

Returns `true` if the list of not disabled issues is empty, `false` otherwise.